
// This script skips diverse redirects.

var IPV4ADDRESS = "((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5]))";
var IP_LITERAL = "(\\[((([a-f\\d]{1,4}:){6}([a-f\\d]{1,4}:[a-f\\d]{1,4})|" + IPV4ADDRESS + ")|(::([a-f\\d]{1,4}:){5}([a-f\\d]{1,4}:[a-f\\d]{1,4})|" + IPV4ADDRESS + ")|(([a-f\\d]{1,4})?::([a-f\\d]{1,4}:){4}([a-f\\d]{1,4}:[a-f\\d]{1,4})|" + IPV4ADDRESS + ")|((([a-f\\d]{1,4}:)?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:){3}([a-f\\d]{1,4}:[a-f\\d]{1,4})|" + IPV4ADDRESS + ")|(((([a-f\\d]{1,4}:){1,2})?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:){2}([a-f\\d]{1,4}:[a-f\\d]{1,4})|" + IPV4ADDRESS + ")|(((([a-f\\d]{1,4}:){1,3})?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:[a-f\\d]{1,4})|" + IPV4ADDRESS + ")|(((([a-f\\d]{1,4}:){1,4})?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:[a-f\\d]{1,4})|" + IPV4ADDRESS + ")|(((([a-f\\d]{1,4}:){1,5})?[a-f\\d]{1,4})?::[a-f\\d]{1,4})|(((([a-f\\d]{1,4}:){1,6})?[a-f\\d]{1,4})?::))\\])";
var IP = "(" + IPV4ADDRESS + "|" + IP_LITERAL + ")";

/*
 * HTTPURL - RFC 1738
 */
var SCHEME = "https?:";
var DOMAINLABEL = "([a-z\\d]|([a-z\\d]([a-z\\d-]*[a-z\\d])))";
var TOPLABEL = "([a-z]([a-z\\d-]*[a-z\\d])?)";
var HOSTNAME = "((" + DOMAINLABEL + "\\.)*" + TOPLABEL + ")";
var HOSTNUMBER = "(" + IPV4ADDRESS + "|" + IP_LITERAL + ")";
var HOST = "(" + HOSTNAME + "|" + HOSTNUMBER + ")";
var PORT = "(:\\d+)?";
var HOSTPORT = "(" + HOST + PORT + ")";
//var HSEGMENT = "([\\w-$.+!*'(),;:@&=]|%[a-f\\d]{2})*";
var HSEGMENT = "([\\w-$.!*'(),;:@&=]|%[a-f\\d]{2})*"; // REMOVED +
var HPATH = "(" + HSEGMENT + "(\\/" + HSEGMENT + ")*)";
var SEARCH = HSEGMENT;
//var HTTPURL = SCHEME + "\\/\\/" + HOSTPORT + "(/" + HPATH + "(\\?" + SEARCH + ")?)?";
var HTTPURL = SCHEME + "\\/\\/" + HOSTPORT + "(/" + HPATH + ")?([&?]" + SEARCH + ")?(#" + HSEGMENT + ")?";

/*
 * HTTPURL - NO SCHEME, SPECIFIC DOMAINLABEL AND TOP-LEVEL DOMAIN
 */
var TLD = "(ac|ad|aero|ae|af|ag|ai|al|am|an|ao|aq|arpa|ar|asia|as|at|au|aw|ax|az|ba|bb|bd|be|bf|bg|bh|biz|bi|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|cat|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|coop|com|co|cr|cu|cv|cx|cy|cz|de|dj|dk|dm|do|dz|ec|edu|ee|eg|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gg|gh|gi|gl|gm|gn|gov|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|info|int|in|io|iq|ir|is|it|je|jm|jobs|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|me|mg|mh|mil|mk|ml|mm|mn|mobi|mo|mp|mq|mr|ms|mt|museum|mu|mv|mw|mx|my|mz|name|na|nc|net|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|org|pa|pe|pf|pg|ph|pk|pl|pm|pn|pro|pr|ps|pt|pw|py|qa|re|ro|rs|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|sk|sl|sm|sn|so|sr|st|su|sv|sy|sz|tc|td|tel|tf|tg|th|tj|tk|tl|tm|tn|to|tp|travel|tr|tt|tv|tw|tz|ua|ug|uk|um|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|xn--0zwm56d|xn--11b5bs3a9aj6g|xn--80akhbyknj4f|xn--9t4b11yi5a|xn--deba0ad|xn--g6w251d|xn--hgbk6aj7f53bba|xn--hlcj6aya9esc7a|xn--jxalpdlp|xn--kgbechtv|xn--zckzah|ye|yt|yu|za|zm|zw)";
var HOSTNAME2 = "((" + DOMAINLABEL + "\\.)+" + TLD + ")";
var HOST2 = "(" + HOSTNAME2 + "|" + HOSTNUMBER + ")";
var HOSTPORT2 = "(" + HOST2 + PORT + "\\b)";
var HTTPURL2 = HOSTPORT2 + "(/" + HPATH + "(\\?" + SEARCH + ")?)?";

var uriRegExp = new RegExp(HTTPURL + "|" + HTTPURL2, "gi");
var domainRegExp = new RegExp("^((" + SCHEME + "\\/\\/)?" + HOSTPORT + "\\b)", "i");
var unwantedRegExp = new RegExp("^((" + SCHEME + "?(\\/*([-.~!$&'()*+,;=:\\d]{1,3})?))|(\\[?(\\d+\\.){3}\\d+(\\/+\\d+)?\\]?))$", "i"); // SCHEME-ONLY WITH SOME SEPECIAL SYMBOLS OR IP-ONLY WITH OPTIONAL DIGIT PATH
var schemeRegExp = new RegExp("^" + SCHEME, "i");

var SEPARATOR = /[?&=+]/;
var BEGINNING = /^[^?&=]+[?&=]/;

var urls = null;

function frameRedirection()
{
  try {
    var frames = document.evaluate(".//frame[@src]", document.body, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
    if (!frames || frames.snapshotLength != 1) { return; }

    window.location.replace(frames.snapshotItem(0).src);
  } catch (e) {}
}

function skipRedirect(value)
{
  if (!value) { return; }

  if (value.indexOf("%") > -1) {
    var arr = value.split(SEPARATOR);
    for (var i = 0; i < arr.length; i++) {
      if (arr[i].length < 4) { continue; }

      if (arr[i].indexOf("%") > -1) {
        var tmp = unescape(arr[i]);
        if (tmp == arr[i]) { continue; }

        arr[i] = tmp;
      }
      skipRedirect(arr[i]);
    }
  } else {
    var uris = value.replace(/\ /g, "%20").match(uriRegExp);
    if (!uris) { return; }

    for (var j = 0; j < uris.length; j++) {
      var url = uris[j];
      if (unwantedRegExp.test(url)) { continue; }

      if (/[?&]/.test(url)) { skipRedirect(url.replace(BEGINNING, "")); }
      if (!schemeRegExp.test(url)) { url = "http://" + url; }
      urls.obj[url] = true;
    }
  }
}

function removeUnwanted(value)
{
  return (/[\-~=_,;:!?.'()\[@$*&#+]/).test(value.charAt(value.length - 1)) ? removeUnwanted(value.substring(0, value.length - 1)) : value;
}

function urlRedirection()
{
  var anchors = document.evaluate(".//a[contains(@href,'?') or contains(@href,'&')]", document.body, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
  if (anchors && anchors.snapshotLength > 0) {
    for (var i = 0; i < anchors.snapshotLength; i++) {
      urls = {};
      urls.obj = {};
      var anchor = anchors.snapshotItem(i);
      var href = anchor.getAttribute("href");
      skipRedirect(href.replace(BEGINNING, "").replace(/\s+$/, ""));
      href = "";
      var isDomain = false;
      for (var url in urls.obj) { if (url) {
          var urlIsDomain = domainRegExp.test(url);
          var urlIsLonger = url.length > href.length;
          if (urlIsDomain && urlIsLonger || (!isDomain && (urlIsDomain || urlIsLonger))) {
            href = url;
            isDomain = urlIsDomain;
          }
      }}
      if (href) { anchor.setAttribute("href", removeUnwanted(href)); }
    }
  }
}

function main()
{
  document.normalize();
  frameRedirection();
  urlRedirection();
/*  try{frameRedirection();}catch(e){}
  try{urlRedirection();}catch(e){}*/
}

main();
